﻿:Class  ScriptManager
⍝ User Command script for "ScriptManager"
⍝ Kai Jaeger
⍝ Version 1.1 from 2011-08-04

    ∇ r←List;⎕IO;⎕ML ⍝ this function usually returns 1 or more namespaces (here only 1)
      :Access Shared Public
      ⎕IO←⎕ML←1
      r←⎕NS''                             ⍝ create the command
      r.Name←'ScriptManager'              ⍝ the name
      r.Desc←'Starts ScriptManager'
      r.Group←⊂''                                     ⍝
     ⍝ Parsing rules for each:
      r.Parse←'1'              ⍝ takes 1 argument
    ∇

    ∇ r←Run(Cmd Args);browser;cmdparser;cs;ref;⎕IO;⎕ML;path;regKey
      :Access Shared Public
      ⎕IO←⎕ML←1
      r←''
      regKey←'HKEY_CURRENT_USER\Software\Dyalog\Dyalog APL/W 12.1 Unicode\SALT\CodeFolder'
      path←ReadRegKey regKey
      path,←'\ScriptManager.DWS'
     
      ref←⎕NS''
      ref.⎕CY path
      ref.ScriptManager.Run'' ⍝ ref
     
    ∇

    ∇ r←Help Cmd;⎕IO;⎕ML;sep
      ⎕IO←⎕ML←1
      sep←⎕TC[3]
      :Access Shared Public      
      r←'Starts ScriptManager. You can specify a ref pointing to a ',sep
      r,←'script as right argument if you want to highlight that script ',sep
      r,←'right from the start; otherwise specify an empty vector: ⍬',sep
    ∇

    ∇ r←{default}ReadRegKey key;wsh;⎕WX
     ⍝ Read a registry key. Uses a particular default path which can be _
     ⍝ overridden via the left argument
      :Access public shared
      ⎕WX←1
      default←{0<⎕NC ⍵:⍎⍵ ⋄ ''}'default'
      'wsh'⎕WC'OLEClient' 'WScript.Shell'
      :Trap 11
          r←wsh.RegRead key
      :Else
          r←default
      :EndTrap
    ∇

:EndClass